import { useState, useRef, useEffect } from 'react';

var set = false;
function initCor() {
  var cache = {};
  if (set) return;
  setInterval(function () {
    set = true;

    try {
      if (!window.Cor) window.Cor = {};
      var keys = Object.keys(window.Cor);
      var changedKeys = [];

      for (var _i = 0, _keys = keys; _i < _keys.length; _i++) {
        var _window$Cor;

        var key = _keys[_i];

        if (JSON.stringify(cache[key]) !== JSON.stringify((_window$Cor = window.Cor) == null ? void 0 : _window$Cor[key])) {
          changedKeys.push(key);
          cache[key] = window.Cor[key];
        }
      }

      var corEvent = new CustomEvent('Cor', {
        detail: changedKeys
      });
      window.dispatchEvent(corEvent); // window.postMessage({ changedKeys }, '*');
    } catch (error) {
      console.log('error @initCor Cor listener', error);
    }
  }, 120);
}

function useCor(_ref) {
  var _ref$keys = _ref.keys,
      keys = _ref$keys === void 0 ? [] : _ref$keys,
      onChange = _ref.onChange,
      defaultValues = _ref.defaultValues;

  var _useState = useState(false),
      flag = _useState[0],
      triggerRerender = _useState[1];

  var set = useRef(false);
  useEffect(function () {
    if (set.current) return;
    set.current = true;
    if (!window.Cor) window.Cor = {};

    if (defaultValues) {
      for (var _i = 0, _Object$keys = Object.keys(defaultValues); _i < _Object$keys.length; _i++) {
        var _window$Cor;

        var key = _Object$keys[_i];

        if (!((_window$Cor = window.Cor) != null && _window$Cor[key])) {
          window.Cor[key] = defaultValues[key];
        }
      }

      triggerRerender(function (prev) {
        return !prev;
      });
    }

    window.addEventListener('Cor', function (_ref2) {
      var detail = _ref2.detail;
      if (!detail) return;

      if (keys.some(function (key) {
        return detail.includes(key);
      })) {
        triggerRerender(function (prev) {
          return !prev;
        });
        onChange && onChange(detail);
      }
    });
  }, []);

  function c(action) {
    if (typeof action === 'string') {
      return window.Cor[action];
    } else {
      var _keys = Object.keys(action);

      if (!_keys || _keys.length === 0) return;

      for (var _i2 = 0, _keys2 = _keys; _i2 < _keys2.length; _i2++) {
        var key = _keys2[_i2];

        try {
          window.Cor[key] = action[key];
        } catch (error) {
          console.log("error setting key", {
            action: action,
            error: error
          });
        }
      }

      var corEvent = new CustomEvent('Cor', {
        detail: _keys
      });
      window.dispatchEvent(corEvent);
    }
  }

  return {
    flag: flag,
    c: c
  };
}

function useCor$1(_ref) {
  var _ref$keys = _ref.keys,
      keys = _ref$keys === void 0 ? [] : _ref$keys,
      onChange = _ref.onChange,
      defaultValues = _ref.defaultValues;

  var _useState = useState(false),
      flag = _useState[0],
      triggerRerender = _useState[1];

  var set = useRef(false);
  useEffect(function () {
    if (set.current) return;
    set.current = true;
    if (!window.Cor) window.Cor = {};

    if (defaultValues) {
      for (var _i = 0, _Object$keys = Object.keys(defaultValues); _i < _Object$keys.length; _i++) {
        var _window$Cor;

        var key = _Object$keys[_i];

        if (!((_window$Cor = window.Cor) != null && _window$Cor[key])) {
          window.Cor[key] = defaultValues[key];
        }
      }

      triggerRerender(function (prev) {
        return !prev;
      });
    }

    window.addEventListener('Cor', function (_ref2) {
      var detail = _ref2.detail;
      if (!detail) return;

      if (keys.some(function (key) {
        return detail.includes(key);
      })) {
        triggerRerender(function (prev) {
          return !prev;
        });
        onChange && onChange(detail);
      }
    });
  }, []);

  function Cor(key) {
    return {
      get: function get() {
        return window.Cor[key];
      },
      set: function set(value) {
        window.Cor[key] = value;
        var corEvent = new CustomEvent('Cor', {
          detail: [key]
        });
        window.dispatchEvent(corEvent);
      }
    };
  }

  return {
    flag: flag,
    Cor: Cor
  };
}

function useCor$2(_ref) {
  var _ref$keys = _ref.keys,
      keys = _ref$keys === void 0 ? [] : _ref$keys,
      onChange = _ref.onChange,
      defaultValues = _ref.defaultValues;

  var _useState = useState(false),
      flag = _useState[0],
      triggerRerender = _useState[1];

  var set = useRef(false);
  useEffect(function () {
    if (set.current) return;
    set.current = true;
    if (!window.Cor) window.Cor = {};

    if (defaultValues) {
      for (var _i = 0, _Object$keys = Object.keys(defaultValues); _i < _Object$keys.length; _i++) {
        var _window$Cor;

        var key = _Object$keys[_i];

        if (!((_window$Cor = window.Cor) != null && _window$Cor[key])) {
          window.Cor[key] = defaultValues[key];
        }
      }

      triggerRerender(function (prev) {
        return !prev;
      });
    }

    window.addEventListener('Cor', function (_ref2) {
      var detail = _ref2.detail;
      if (!detail) return;

      if (keys.some(function (key) {
        return detail.includes(key);
      })) {
        triggerRerender(function (prev) {
          return !prev;
        });
        onChange && onChange(detail);
      }
    });
  }, []);
  return {
    flag: flag
  };
}

export { initCor, useCor, useCor$1 as useCorContained, useCor$2 as useCorDependend };
//# sourceMappingURL=cor-state.esm.js.map
